"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  base_event: () => base_event,
  dedupeEditEvents: () => dedupeEditEvents,
  editComponentLocationEvent: () => editComponentLocationEvent,
  editTraceHintEvent: () => editTraceHintEvent
});
module.exports = __toCommonJS(src_exports);

// src/edit-events-zod.ts
var import_zod = require("zod");
var base_event = import_zod.z.object({
  edit_event_id: import_zod.z.string(),
  in_progress: import_zod.z.boolean().optional(),
  created_at: import_zod.z.number()
});
var editComponentLocationEvent = base_event.extend({
  pcb_edit_event_type: import_zod.z.literal("edit_component_location"),
  pcb_component_id: import_zod.z.string(),
  original_center: import_zod.z.object({ x: import_zod.z.number(), y: import_zod.z.number() }),
  new_center: import_zod.z.object({ x: import_zod.z.number(), y: import_zod.z.number() })
});
var editTraceHintEvent = base_event.extend({
  pcb_edit_event_type: import_zod.z.literal("edit_trace_hint"),
  pcb_port_id: import_zod.z.string(),
  pcb_trace_hint_id: import_zod.z.string().optional(),
  route: import_zod.z.array(
    import_zod.z.object({ x: import_zod.z.number(), y: import_zod.z.number(), via: import_zod.z.boolean().optional() })
  )
});

// src/dedupe-edit-events.ts
var dedupeEditEvents = (events) => {
  events.sort((a, b) => a.created_at - b.created_at);
  const dedupedEvents = [];
  const portsWithTraceHints = /* @__PURE__ */ new Set();
  for (const event of events) {
    if (event.pcb_edit_event_type === "edit_trace_hint") {
      if (portsWithTraceHints.has(event.pcb_port_id)) {
        continue;
      }
      dedupedEvents.push(event);
    } else {
      dedupedEvents.push(event);
    }
  }
  return dedupedEvents;
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  base_event,
  dedupeEditEvents,
  editComponentLocationEvent,
  editTraceHintEvent
});
//# sourceMappingURL=index.js.map